##############################################################
#
#        MILD-RESTRICTED  FACTOR  ANALYSIS     R   CODE
#
#                 AUTHOR:   URBANO LORENZO-SEVA
#
#                     URV, TARRAGONA (SPAIN)
#                       DATE: 20/11/2023
#
# DATA EXAMPLE: 10 ITEMS AND N = 1,000
#
# DATA TEXT FILE USED:      data.dat
#
# LOADING MATRIX MODEL:     LoadingMatrixModel.dat
#
# PHI MATRIX MODEL:         PHIMatrixModel.dat
#
# DOUBLEST FREE IN MODEL:   DoubletsFreeModel.dat
#
# EXECUTE THE THIS EXAMPLES AS
#
# source("Example_MildRestrictedFactorAnalysis.r")
#
##############################################################

##############################################################
# UPDATE HERE THE NAME OF YOUR INPUT DATA FILE
#
# A TEXT FILE WITH NO LABELS IS EXPECTED
#
filein <- "data.dat"
# 
# UPDATE HERE THE FILE NAME WITH THE SPECIFIED LOADING MATRIX  
# OF THE MODEL.
#
# A SPECIFIED VALUE OF 9 MEANS THAT THE CORRESPONDING 
# LOADING VALUE IS SPECIFIED AS A FREE LOADING VALUE
#
fileinP <- "LoadingMatrixModel.dat"
# 
# UPDATE HERE THE FILE NAME WITH THE SPECIFIED PHI MATRIX OF THE MODEL.
#
# A SPECIFIED VALUE OF 9 MEANS THAT THE CORRESPONDING CORRELATION 
# INDEX IS SPECIFIED AS A FREE CORRELATION. IF ALL THE FACTORS ARE
# LEFT TO CORRELATE OR THE NUMBER OF FACTORS IN THE MODEL IS 1
# THEN THERE IS NOT NEED TO SPEFICY A PHI MATRIX: IN THSI CASE THE
# COMMAND MUST BE
#
# fileinPHI <- "" 
#
 fileinPHI <- "PHIMatrixModel.dat"
# 
# 
# UPDATE HERE THE FILE NAME WITH THE DOUBLEST FREE IN THE MODEL
#
# THE CONTENT IN THE FILE HAS TO BE ONE ROW FOR DOUBLET AND THREE
# COMLUMNS. THE TWO FIRST COLUMNS ARE THE INDEX OF THE PAIR AND
# THE THIRD COLUMN IS THE SPEFICIED VALUE. A SPECIFIED VALUE
# OF 9 MEANS THAT THE DOUBLETS IS LET FREE 
# 
# IF NO DOUBLETS ARE SPECIFIED, THEN THE COMMAND HAS TO BE
# 
# fileinDoublets <- ""
#
 fileinDoublets <- "DoubletsFreeModel.dat"
# 
# 
# UPDATE HERE THE NUMBER OF RANDOM SAMPLES FOR LOSEFER (AT LEAST 1000)
# 
K <- 1000
#
#
##############################################################
source("MildRestrictedFA.rlib")
MildRestrictedFactorAnalysis(filein, fileinP, fileinPHI, fileinDoublets, K)